@Grab('org.slf4j:slf4j-simple:1.7.12')
@Grab('io.ratpack:ratpack-groovy:1.0.0')
@Grab('mysql:mysql-connector-java:5.1.6')

@GrabConfig(systemClassLoader = true)

import static ratpack.groovy.Groovy.ratpack
import groovy.sql.Sql
import ratpack.form.Form

ratpack {
    handlers {

        get("status/") {
            def statusCodes = [100, 200, 202, 200, 403, 404, 200, 500, 200, 400]
            Random random = new Random()
            def code = statusCodes[random.nextInt(10 ** 1)]
            response.status(code)
            render "Nyt endpoint ${code}"
        }

        get("sleep/") {
            Random random = new Random()
            int i = random.nextInt(10 ** 3)
            sleep(i)
            render "Sleep ${i}"
        }

        get {
            def sql=Sql.newInstance("jdbc:mysql://localhost/flug_demo", "flug_demo", "flug_demo", "com.mysql.jdbc.Driver")
            String output = ''
            sql.eachRow('SELECT * FROM gatling_data') { data ->
                output += data.data + " " + data.val + "\n"
            }
            render "Hello World! ${output}"
        }

        post("update/:id") {
            parse(Form).then { Form form ->
	            String username = form.username
                String password = form.password
                def sql = Sql.newInstance("jdbc:mysql://localhost/flug_demo", "flug_demo", "flug_demo", "com.mysql.jdbc.Driver")
                def params = ['Endpoint', pathTokens.id +"-"+ username, password]
                def data = sql.execute('INSERT INTO gatling_data (endpoint, data, val) VALUES (?, ?, ?)', params)
                render "${username}\n\n"
	        }
        }

    }
}
