import scala.language.implicitConversions

case class Point(x : Int, y : Int) {
  // Operator overloading
  def * (mul: Point) : Point = {
    new Point(x * mul.x, y * mul.y)
  }
  def * (mul: Int) : Point = {
    new Point(x * mul, y * mul)
  }
}

implicit def intToPoint(z : Int) : Point = new Point(z, z)

def p1 = new Point(2, 4)
println(p1 * p1) // Out: Point(4,16)
// Mulig uden implicit
println(p1 * 3)  // Out: Point(6,12)
// Kun med implicit
println(3 * p1)  // Out: Point(6,12)
