package dk.workbench

import io.gatling.core.Predef._
import io.gatling.http.Predef._
import scala.concurrent.duration._

class AdvancedSimulation extends Simulation {

  val users = System.getProperty("users", "10").toInt
  val rampup = System.getProperty("rampup", "1").toInt

  val httpconf = http
      .baseURL("http://127.0.0.1:5050")

  val index = scenario("Test Status")
        .exec(http("index-request").get("/status/"))

  val multiStep = scenario("Test scenario")
      .exec(
        group("Grupperet Test scenario") {
          exec(http("index-get-request").get("/"))
          .exec(http("randomsleep-get-request").get("/sleep/"))
        }
      )
      .pause(0.05 seconds)
      .exec(http("randomstatus-get-request").get("/status/"))



  setUp(
    multiStep.inject(rampUsers(users) over (rampup minutes)),
    index.inject(rampUsersPerSec(5) to(50) during (2 minutes))
  )
  .assertions(global.failedRequests.percent.lessThan(2))
  .protocols(httpconf)
}
