package dk.workbench

import io.gatling.core.Predef._
import io.gatling.http.Predef._
import scala.concurrent.duration._

class BasicSimulation extends Simulation {

  val httpConf = http
    .baseURL("http://workbench.dk")
    .acceptHeader("text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8")
    .userAgentHeader("Mozilla/5.0 (Windows NT 5.1; rv:31.0) Gecko/20100101 Firefox/31.0")

  val scn = scenario("BasicSimulation")
    .exec(http("request_index")
    .get("/").check(substring("hello world")))
    .pause(5)

  setUp(
    scn.inject(atOnceUsers(1))
  )
  .assertions(
      forAll.responseTime.max.lessThan(6),
      global.failedRequests.percent.lessThan(2)
  )
  .protocols(httpConf)
}