package dk.workbench

import io.gatling.core.Predef._
import io.gatling.http.Predef._
import scala.concurrent.duration._

class LoginSimulation extends Simulation {
    val users = System.getProperty("users", "10").toInt
    val rampup = System.getProperty("rampup", "1").toInt
    val postData = csv("src/test/resources/data.csv").random

    val httpconf = http
        .baseURL("http://127.0.0.1:5050")

    val loginForm = exec(
      http("LoginForm: ${username} ${password}")
        .post("/update/${id}")                 // id er feltnavn fra CSV filen
        .formParam("username", "${username}")  // username er feltnavn fra CSV filen
        .formParam("password", "${password}")  // password er feltnavn fra CSV filen
    )

    val loginBasicAuth = exec(
      http("BasicAuth: ${username} ${password}")
        .post("/access/${id}")
        .basicAuth("${username}", "${password}")
    )

    val login = scenario("Login scenario")
      .feed(postData)
      .exec(
        group("Poster login") {
          loginForm
        }
      )

    setUp(
      login.inject(rampUsers(users) over (rampup minutes))
    )
    .protocols(httpconf)
}
